Budget
BudgetConfiguration object
- budget_configuration_idstringuuid
<Databricks> budget configuration ID.
- account_idstringuuid
<Databricks> account ID.
- create_timeint64
Creation time of this budget configuration.
- update_timeint64
Update time of this budget configuration.
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- alert_configuration_idstringuuid
<Databricks> alert configuration ID.
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_configuration_idstringuuid
<Databricks> action configuration ID.
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Get budget GA
GET
Gets a budget configuration for an account. Both account and budget configuration are specified by ID.
API scopes: billing
Parameters
- account_idstringuuidRequiredpath
<Databricks> account ID.
- budget_idstringuuidRequiredpath
The budget configuration ID
Response
- budgetobject
Show child attributesHide child attributes
- budget_configuration_idstringuuid
<Databricks> budget configuration ID.
- account_idstringuuid
<Databricks> account ID.
- create_timeint64
Creation time of this budget configuration.
- update_timeint64
Update time of this budget configuration.
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- alert_configuration_idstringuuid
<Databricks> alert configuration ID.
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_configuration_idstringuuid
<Databricks> action configuration ID.
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Get all budgets GA
GET
Gets all budgets associated with this account.
API scopes: billing
Parameters
- account_idstringuuidRequiredpath
<Databricks> account ID.
- page_tokenstringquery
A page token received from a previous get all budget configurations call. This token can be used to retrieve the subsequent page. Requests first page if absent.
Response
Returns a list of BudgetConfiguration objects.
Create new budget GA
POST
Create a new budget configuration for an account. For full details, see https://docs.databricks.com/en/admin/account-settings/budgets.html.
API scopes: billing
Parameters
- account_idstringuuidRequiredpath
<Databricks> account ID.
Request body
- budgetobjectRequired
Properties of the new budget configuration.
Show child attributesHide child attributes
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Response
- budgetobject
The created budget configuration.
Show child attributesHide child attributes
- budget_configuration_idstringuuid
<Databricks> budget configuration ID.
- account_idstringuuid
<Databricks> account ID.
- create_timeint64
Creation time of this budget configuration.
- update_timeint64
Update time of this budget configuration.
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- alert_configuration_idstringuuid
<Databricks> alert configuration ID.
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_configuration_idstringuuid
<Databricks> action configuration ID.
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Modify budget GA
PUT
Updates a budget configuration for an account. Both account and budget configuration are specified by ID.
API scopes: billing
Parameters
- account_idstringuuidRequiredpath
<Databricks> account ID.
- budget_idstringRequiredpath
The <Databricks> budget configuration ID.
Request body
- budgetobjectRequired
The updated budget. This will overwrite the budget specified by the budget ID.
Show child attributesHide child attributes
- budget_configuration_idstringuuid
<Databricks> budget configuration ID.
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- alert_configuration_idstringuuid
<Databricks> alert configuration ID.
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_configuration_idstringuuid
<Databricks> action configuration ID.
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Response
- budgetobject
The updated budget.
Show child attributesHide child attributes
- budget_configuration_idstringuuid
<Databricks> budget configuration ID.
- account_idstringuuid
<Databricks> account ID.
- create_timeint64
Creation time of this budget configuration.
- update_timeint64
Update time of this budget configuration.
- alert_configurationsarray of object
Alerts to configure when this budget is in a triggered state. Budgets must have at least one alert configuration. A budget can have up to four shared alerts per time period, each with a unique
quantity_threshold. Budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAYcan also use per-user alerts, with optionalprincipal_overrides. These budgets can have at most one per-user alert per time period, and can use shared alerts, a per-user alert, or both. TheBLOCK_USAGEaction is only supported on budgets withresource_typeset toBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. At most one shared alert per time period can have aBLOCK_USAGEaction, and it must be the shared alert with the highest threshold in that period.Show child attributesHide child attributes
- alert_configuration_idstringuuid
<Databricks> alert configuration ID.
- time_periodstring
The time window of usage data for the budget.
MONTH
- trigger_typestring
The evaluation method to determine when this budget alert is in a triggered state.
CUMULATIVE_SPENDING_EXCEEDED
- quantity_typestring
The way to calculate cost for this budget alert. This is what
quantity_thresholdis measured in.LIST_PRICE_DOLLARS_USD
- quantity_thresholdstring
The threshold for the budget alert to determine if it is in a triggered state. The number is evaluated based on
quantity_type.
- action_configurationsarray of object
Configured actions for this alert. These define what happens when an alert enters a triggered state.
Show child attributesHide child attributes
- action_configuration_idstringuuid
<Databricks> action configuration ID.
- action_typestring
The type of the action.
EMAIL_NOTIFICATIONBLOCK_USAGEBeta
- targetstring
Target for the action. For example, an email address.
- scope_typestringBeta
How the alert threshold is evaluated. Determines whether spend is tracked in aggregate or per individual user.
ALERT_CONFIGURATION_SCOPE_TYPE_SHAREDALERT_CONFIGURATION_SCOPE_TYPE_PER_USER
- principal_overridesarray of objectBeta
Per-principal threshold overrides for this alert. Only applies to per-user alerts (
scope_type=ALERT_CONFIGURATION_SCOPE_TYPE_PER_USER); ignored for shared alerts.Show child attributesHide child attributes
- principal_idint64Beta
Account-level principal id (user, group, or service principal).
- override_thresholdstringBeta
Dollar amount that overrides the parent alert's quantity_threshold for this principal.
- filterobject
Configured filters for this budget. These are applied to your account's usage to limit the scope of what is considered for this budget. Leave empty to include all usage for this account. All provided filters must be matched for usage to be included.
Show child attributesHide child attributes
- workspace_idobject
If provided, usage must match with the provided <Databricks> workspace IDs.
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of int64
- tagsarray of object
A list of tag keys and values that will limit the budget to usage that includes those specific custom tags. Tags are case-sensitive and should be entered exactly as they appear in your usage data.
Show child attributesHide child attributes
- keystring
- valueobject
Show child attributesHide child attributes
- operatorstring
IN
- valuesarray of string
- display_namestring
Human-readable name of budget configuration. Max Length: 128
- include_external_spendbooleanBeta
Whether this budget tracks external pass-through spend (third-party costs billed through a <Databricks> product) in addition to internal <Databricks> spend. Only applicable to Unity Gateway budgets, i.e. when
resource_typeisBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY. This field is immutable after create.
- resource_typestringBeta
The resource scope for this budget. Determines whether the budget tracks all resources or a specific resource.
BUDGET_RESOURCE_TYPE_ALL_RESOURCESBUDGET_RESOURCE_TYPE_UNITY_AI_GATEWAY
Delete budget GA
DELETE
Deletes a budget configuration for an account. Both account and budget configuration are specified by ID. This cannot be undone.
API scopes: billing
Parameters
- account_idstringuuidRequiredpath
<Databricks> account ID.
- budget_idstringuuidRequiredpath
The <Databricks> budget configuration ID.